import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_CreateBotAliasCommand, se_CreateBotAliasCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CreateBotAliasCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("LexModelBuildingServiceV2", "CreateBotAlias", {})
    .n("LexModelsV2Client", "CreateBotAliasCommand")
    .f(void 0, void 0)
    .ser(se_CreateBotAliasCommand)
    .de(de_CreateBotAliasCommand)
    .build() {
}
