import { checkExceptions, createWaiter, WaiterState } from "@smithy/util-waiter";
import { DescribeBotLocaleCommand } from "../commands/DescribeBotLocaleCommand";
const checkState = async (client, input) => {
    let reason;
    try {
        const result = await client.send(new DescribeBotLocaleCommand(input));
        reason = result;
        try {
            const returnComparator = () => {
                return result.botLocaleStatus;
            };
            if (returnComparator() === "Built") {
                return { state: WaiterState.SUCCESS, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                return result.botLocaleStatus;
            };
            if (returnComparator() === "ReadyExpressTesting") {
                return { state: WaiterState.SUCCESS, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                return result.botLocaleStatus;
            };
            if (returnComparator() === "NotBuilt") {
                return { state: WaiterState.SUCCESS, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                return result.botLocaleStatus;
            };
            if (returnComparator() === "Deleting") {
                return { state: WaiterState.FAILURE, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                return result.botLocaleStatus;
            };
            if (returnComparator() === "Failed") {
                return { state: WaiterState.FAILURE, reason };
            }
        }
        catch (e) { }
    }
    catch (exception) {
        reason = exception;
    }
    return { state: WaiterState.RETRY, reason };
};
export const waitForBotLocaleCreated = async (params, input) => {
    const serviceDefaults = { minDelay: 10, maxDelay: 120 };
    return createWaiter({ ...serviceDefaults, ...params }, input, checkState);
};
export const waitUntilBotLocaleCreated = async (params, input) => {
    const serviceDefaults = { minDelay: 10, maxDelay: 120 };
    const result = await createWaiter({ ...serviceDefaults, ...params }, input, checkState);
    return checkExceptions(result);
};
