import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { LexModelsV2ClientResolvedConfig } from "../LexModelsV2Client";
export interface LexModelsV2HttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface LexModelsV2HttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    LexModelsV2ClientResolvedConfig,
    HandlerExecutionContext,
    LexModelsV2HttpAuthSchemeParameters,
    object
  > {}
export declare const defaultLexModelsV2HttpAuthSchemeParametersProvider: (
  config: LexModelsV2ClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<LexModelsV2HttpAuthSchemeParameters>;
export interface LexModelsV2HttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<LexModelsV2HttpAuthSchemeParameters> {}
export declare const defaultLexModelsV2HttpAuthSchemeProvider: LexModelsV2HttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: LexModelsV2HttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: LexModelsV2HttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
