import { WaiterConfiguration, WaiterResult } from "@smithy/util-waiter";
import { DescribeBotLocaleCommandInput } from "../commands/DescribeBotLocaleCommand";
import { LexModelsV2Client } from "../LexModelsV2Client";
/**
 * Wait unit a bot locale is created
 *  @deprecated Use waitUntilBotLocaleCreated instead. waitForBotLocaleCreated does not throw error in non-success cases.
 */
export declare const waitForBotLocaleCreated: (params: WaiterConfiguration<LexModelsV2Client>, input: DescribeBotLocaleCommandInput) => Promise<WaiterResult>;
/**
 * Wait unit a bot locale is created
 *  @param params - Waiter configuration options.
 *  @param input - The input to DescribeBotLocaleCommand for polling.
 */
export declare const waitUntilBotLocaleCreated: (params: WaiterConfiguration<LexModelsV2Client>, input: DescribeBotLocaleCommandInput) => Promise<WaiterResult>;
